# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.PubSub.V1.Model.CreateSnapshotRequest do
  @moduledoc """
  Request for the `CreateSnapshot` method.

  ## Attributes

  *   `labels` (*type:* `map()`, *default:* `nil`) - Optional. See [Creating and managing labels](https://cloud.google.com/pubsub/docs/labels).
  *   `subscription` (*type:* `String.t`, *default:* `nil`) - Required. The subscription whose backlog the snapshot retains. Specifically, the created snapshot is guaranteed to retain: (a) The existing backlog on the subscription. More precisely, this is defined as the messages in the subscription's backlog that are unacknowledged upon the successful completion of the `CreateSnapshot` request; as well as: (b) Any messages published to the subscription's topic following the successful completion of the CreateSnapshot request. Format is `projects/{project}/subscriptions/{sub}`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :labels => map() | nil,
          :subscription => String.t() | nil
        }

  field(:labels, type: :map)
  field(:subscription)
end

defimpl Poison.Decoder, for: GoogleApi.PubSub.V1.Model.CreateSnapshotRequest do
  def decode(value, options) do
    GoogleApi.PubSub.V1.Model.CreateSnapshotRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.PubSub.V1.Model.CreateSnapshotRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
