# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.PubSub.V1.Model.IngestionDataSourceSettings do
  @moduledoc """
  Settings for an ingestion data source on a topic.

  ## Attributes

  *   `awsKinesis` (*type:* `GoogleApi.PubSub.V1.Model.AwsKinesis.t`, *default:* `nil`) - Optional. Amazon Kinesis Data Streams.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :awsKinesis => GoogleApi.PubSub.V1.Model.AwsKinesis.t() | nil
        }

  field(:awsKinesis, as: GoogleApi.PubSub.V1.Model.AwsKinesis)
end

defimpl Poison.Decoder, for: GoogleApi.PubSub.V1.Model.IngestionDataSourceSettings do
  def decode(value, options) do
    GoogleApi.PubSub.V1.Model.IngestionDataSourceSettings.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.PubSub.V1.Model.IngestionDataSourceSettings do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
