# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.PubSub.V1.Model.ListTopicSubscriptionsResponse do
  @moduledoc """
  Response for the `ListTopicSubscriptions` method.

  ## Attributes

  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - Optional. If not empty, indicates that there may be more subscriptions that match the request; this value should be passed in a new `ListTopicSubscriptionsRequest` to get more subscriptions.
  *   `subscriptions` (*type:* `list(String.t)`, *default:* `nil`) - Optional. The names of subscriptions attached to the topic specified in the request.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :nextPageToken => String.t() | nil,
          :subscriptions => list(String.t()) | nil
        }

  field(:nextPageToken)
  field(:subscriptions, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.PubSub.V1.Model.ListTopicSubscriptionsResponse do
  def decode(value, options) do
    GoogleApi.PubSub.V1.Model.ListTopicSubscriptionsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.PubSub.V1.Model.ListTopicSubscriptionsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
