# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.PubSub.V1.Model.NoWrapper do
  @moduledoc """
  Sets the `data` field as the HTTP body for delivery.

  ## Attributes

  *   `writeMetadata` (*type:* `boolean()`, *default:* `nil`) - Optional. When true, writes the Pub/Sub message metadata to `x-goog-pubsub-:` headers of the HTTP request. Writes the Pub/Sub message attributes to `:` headers of the HTTP request.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :writeMetadata => boolean() | nil
        }

  field(:writeMetadata)
end

defimpl Poison.Decoder, for: GoogleApi.PubSub.V1.Model.NoWrapper do
  def decode(value, options) do
    GoogleApi.PubSub.V1.Model.NoWrapper.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.PubSub.V1.Model.NoWrapper do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
