# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.PubSub.V1.Model.RollbackSchemaRequest do
  @moduledoc """
  Request for the `RollbackSchema` method.

  ## Attributes

  *   `revisionId` (*type:* `String.t`, *default:* `nil`) - Required. The revision ID to roll back to. It must be a revision of the same schema. Example: c7cfa2a8
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :revisionId => String.t() | nil
        }

  field(:revisionId)
end

defimpl Poison.Decoder, for: GoogleApi.PubSub.V1.Model.RollbackSchemaRequest do
  def decode(value, options) do
    GoogleApi.PubSub.V1.Model.RollbackSchemaRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.PubSub.V1.Model.RollbackSchemaRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
