# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.PubSub.V1.Model.Schema do
  @moduledoc """
  A schema resource.

  ## Attributes

  *   `definition` (*type:* `String.t`, *default:* `nil`) - The definition of the schema. This should contain a string representing the full definition of the schema that is a valid schema definition of the type specified in `type`.
  *   `name` (*type:* `String.t`, *default:* `nil`) - Required. Name of the schema. Format is `projects/{project}/schemas/{schema}`.
  *   `revisionCreateTime` (*type:* `DateTime.t`, *default:* `nil`) - Output only. The timestamp that the revision was created.
  *   `revisionId` (*type:* `String.t`, *default:* `nil`) - Output only. Immutable. The revision ID of the schema.
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of the schema definition.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :definition => String.t() | nil,
          :name => String.t() | nil,
          :revisionCreateTime => DateTime.t() | nil,
          :revisionId => String.t() | nil,
          :type => String.t() | nil
        }

  field(:definition)
  field(:name)
  field(:revisionCreateTime, as: DateTime)
  field(:revisionId)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.PubSub.V1.Model.Schema do
  def decode(value, options) do
    GoogleApi.PubSub.V1.Model.Schema.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.PubSub.V1.Model.Schema do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
