# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.PubSub.V1.Model.UpdateTopicRequest do
  @moduledoc """
  Request for the UpdateTopic method.

  ## Attributes

  *   `topic` (*type:* `GoogleApi.PubSub.V1.Model.Topic.t`, *default:* `nil`) - Required. The updated topic object.
  *   `updateMask` (*type:* `String.t`, *default:* `nil`) - Required. Indicates which fields in the provided topic to update. Must be specified and non-empty. Note that if `update_mask` contains "message_storage_policy" but the `message_storage_policy` is not set in the `topic` provided above, then the updated value is determined by the policy configured at the project or organization level.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :topic => GoogleApi.PubSub.V1.Model.Topic.t() | nil,
          :updateMask => String.t() | nil
        }

  field(:topic, as: GoogleApi.PubSub.V1.Model.Topic)
  field(:updateMask)
end

defimpl Poison.Decoder, for: GoogleApi.PubSub.V1.Model.UpdateTopicRequest do
  def decode(value, options) do
    GoogleApi.PubSub.V1.Model.UpdateTopicRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.PubSub.V1.Model.UpdateTopicRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
